
/*
From: "Tobias 'Doping' Bading" <bading@cs.tu-berlin.de>
Subject: extract_frames.c
Date: Mon, 9 May 1994 14:44:32 +0200 (MET DST)
Modified-by: phade ;o)
*/

#include <stdio.h>

#define True  1
#define False 0

int main (int argc, char *argv[])
{
  int zeichen, sync = False;
  int offset = 0, last_offset = 1;
  int anfang, ende, aktuell = -1;
  FILE *s, *t;

  if (argc != 5)
  {
    fprintf (stderr, "usage: mp2split source target #start #end\n");
    exit (0);
  }
  sscanf (argv[3], "%d", &anfang);
  sscanf (argv[4], "%d", &ende);
  s = fopen (argv [1], "rb");
  t = fopen (argv [2], "wb");
  fputc ('\377', t);
  for (;;)
  {
    if ((zeichen = fgetc (s)) == EOF)
      break;
    if (sync && (zeichen & 0xF0) == 0xF0 && zeichen != 255)
    {
      /* Syncwort gefunden */
      last_offset = offset;
      sync = False;
      if (++aktuell > ende)
        break;
    }
    else
      if (zeichen == 255)
        sync = True;
      else
        sync = False;
    if (aktuell >= anfang)
      fputc (zeichen, t);
    ++offset;
  }
  fclose (s);
  fclose (t);

  return 0;
}

